/*
// This file has been patched in order to use the O2 database
// on Thu May 27 11:48:17 1999
*/


/////////////////////////////////////////////////////////////////////
// OCB (the Object Clustering Benchmark)
// Version 1.0 OCB/O2, janvier 1999
// Fromantin Christophe
// LIMOS, Blaise Pascal University (Clermont-Ferrand II), France
/////////////////////////////////////////////////////////////////////
// ocbclasseso2.hh: Classes definition
/////////////////////////////////////////////////////////////////////
  
class OCB_Object;
/////////////////////////////////////////////////////////////////////
// CLASS Class
/////////////////////////////////////////////////////////////////////


#ifndef __ODMG_93__   // patch of class OCB_Class
class OCB_Class {

  public:

    // Public attributes
    int     Id;
    int     MAXNREF;
    int     BASESIZE;
    int     Nb_Object;
    d_Array<int > TRef;
    d_Array<d_Ref<OCB_Class> >CRef;
    int     InstanceSize;
    d_List<d_Ref<OCB_Object> >Iterator;
    
    // Methods
    OCB_Class();     // Constructor
    
    static d_List<d_Ref<OCB_Class> > *Les_Classes;
    static void Restart_Class(int);
    static void Clear_Class(); 
    static void Read_Class(d_Ref<OCB_Class> &,int);  
    static void Replace_Class(d_Ref<OCB_Class>,int);  
    static void Insert_Class(d_Ref<OCB_Class> &,int,int,int);  
};
#else                 // patch of class OCB_Class
#include "o2_root_defs.hxx"
class OCB_Class : public virtual o2_root {

  public:

    // Public attributes
    int     Id;
    int     MAXNREF;
    int     BASESIZE;
    int     Nb_Object;
    d_Array<int > TRef;
    d_Array<d_Ref<OCB_Class> >CRef;
    int     InstanceSize;
    d_List<d_Ref<OCB_Object> >Iterator;
    
    // Methods

    OCB_Class();     // Constructor
    
    static d_List<d_Ref<OCB_Class> > *Les_Classes;
    static void Restart_Class(int);
    static void Clear_Class(); 
    static void Read_Class(d_Ref<OCB_Class> &,int);  
    static void Replace_Class(d_Ref<OCB_Class>,int);  
    static void Insert_Class(d_Ref<OCB_Class> &,int,int,int);  

protected:
    virtual void   o2_new();
    virtual void   o2_read();
    virtual void   o2_release();
    virtual int    o2_diff();
    virtual void   o2_write();
    virtual int    o2_write_if_diff();
public:
    virtual void*  o2_get_ref() { return this; };
    static  Handle o2_get_class_id();
    static  char*  o2_get_name();
    OCB_Class(o2_Shadow, Handle);
};
#endif                // patch of class OCB_Class


