//
// Copyright (c) 1999 O2Technology. All Rights Reserved
//

// ---------------------------------------
// Include Files
// ---------------------------------------
#include <stdlib.h>
#include "o2_root_defs.hxx"
#include "o2_notification.h"
#include "OCB_Class.hxx"

#include "o2_macros.h"
#ifdef O2_NEED_TMPL_SRC
#include "o2template_CC.cc"
#endif 

// ---------------------------------------
// Global Declarations
// ---------------------------------------
class o2cpp_OCB_Class {
  private:
    static Handle hd;
    static unsigned short trans_nb;
    static o2schema s;
    static Pid att_Id;
    static Pid att_MAXNREF;
    static Pid att_BASESIZE;
    static Pid att_Nb_Object;
    static Pid att_TRef;
    static Pid att_CRef;
    static Pid att_InstanceSize;
    static Pid att_Iterator;
    
  public:
    
    static Pid o2_get_pid_Id() {
      if (!att_Id){
        Sm_meta_prop kind;
        o2_name_to_pid(o2_get_class_id(), "Id", &att_Id, &kind);
      }
      return att_Id;
    }

    static Pid o2_get_pid_MAXNREF() {
      if (!att_MAXNREF){
        Sm_meta_prop kind;
        o2_name_to_pid(o2_get_class_id(), "MAXNREF", &att_MAXNREF, &kind);
      }
      return att_MAXNREF;
    }

    static Pid o2_get_pid_BASESIZE() {
      if (!att_BASESIZE){
        Sm_meta_prop kind;
        o2_name_to_pid(o2_get_class_id(), "BASESIZE", &att_BASESIZE, &kind);
      }
      return att_BASESIZE;
    }

    static Pid o2_get_pid_Nb_Object() {
      if (!att_Nb_Object){
        Sm_meta_prop kind;
        o2_name_to_pid(o2_get_class_id(), "Nb_Object", &att_Nb_Object, &kind);
      }
      return att_Nb_Object;
    }

    static Pid o2_get_pid_TRef() {
      if (!att_TRef){
        Sm_meta_prop kind;
        o2_name_to_pid(o2_get_class_id(), "TRef", &att_TRef, &kind);
      }
      return att_TRef;
    }

    static Pid o2_get_pid_CRef() {
      if (!att_CRef){
        Sm_meta_prop kind;
        o2_name_to_pid(o2_get_class_id(), "CRef", &att_CRef, &kind);
      }
      return att_CRef;
    }

    static Pid o2_get_pid_InstanceSize() {
      if (!att_InstanceSize){
        Sm_meta_prop kind;
        o2_name_to_pid(o2_get_class_id(), "InstanceSize", &att_InstanceSize, &kind);
      }
      return att_InstanceSize;
    }

    static Pid o2_get_pid_Iterator() {
      if (!att_Iterator){
        Sm_meta_prop kind;
        o2_name_to_pid(o2_get_class_id(), "Iterator", &att_Iterator, &kind);
      }
      return att_Iterator;
    }
    static Handle o2_get_class_id() {
      if (trans_nb <= __o2_switch_commit) {
        trans_nb = __o2_switch;
        hd = 0;
      }
      if (!hd)
        hd = o2_exec_id("OCB_Class", O2_CLASS);
        if(!hd) rt_error_class("OCB_Class");
      return hd;
    }
    static o2schema o2_get_schema() {
      if(!s) s = o2_open_schema("s_OCB");
      return s;
    }
};

// ---------------------------------------
// Initialization of static members of the class o2cpp_OCB_Class
// ---------------------------------------
Handle o2cpp_OCB_Class::hd = 0;
unsigned short o2cpp_OCB_Class::trans_nb = __o2_switch;
o2schema o2cpp_OCB_Class::s = 0;
Pid o2cpp_OCB_Class::att_Id = 0;
Pid o2cpp_OCB_Class::att_MAXNREF = 0;
Pid o2cpp_OCB_Class::att_BASESIZE = 0;
Pid o2cpp_OCB_Class::att_Nb_Object = 0;
Pid o2cpp_OCB_Class::att_TRef = 0;
Pid o2cpp_OCB_Class::att_CRef = 0;
Pid o2cpp_OCB_Class::att_InstanceSize = 0;
Pid o2cpp_OCB_Class::att_Iterator = 0;

// ---------------------------------------
//    Functions for late-binding
// ---------------------------------------

extern "C" {
  OCB_Class *o2_OCB_Class_ctr_OCB_Class(Handle);
}

OCB_Class *o2_OCB_Class_ctr_OCB_Class(Handle hd) {
  OCB_Class *r = new OCB_Class((o2_Shadow)0, hd);
  return r;
}

// ---------------------------------------
//    Constructor
// ---------------------------------------
OCB_Class::OCB_Class(o2_Shadow shad, Handle hd) : Iterator(shad) {
  Handle tmp_hd = hd;
  shad = 0;
}

// ---------------------------------------
//    OCB_Class::o2_new
// ---------------------------------------
void OCB_Class::o2_new() {
  o2_create_object(o2cpp_OCB_Class::o2_get_class_id());
}

// ---------------------------------------
//    OCB_Class::o2_read
// ---------------------------------------
void OCB_Class::o2_read() {
  o2ctx o2_ctx = o2_cplusplus_prologue(o2_get_o2oo_handle(), o2cpp_OCB_Class::o2_get_schema());
  
  o2_NewPath_elem o2_path[2];
  
  
  
  // attribute Id
  {
    int o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_Id();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_INT, &o2_entity, 0);
    Id =  o2_entity;
  }

  // attribute MAXNREF
  {
    int o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_MAXNREF();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_INT, &o2_entity, 0);
    MAXNREF =  o2_entity;
  }

  // attribute BASESIZE
  {
    int o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_BASESIZE();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_INT, &o2_entity, 0);
    BASESIZE =  o2_entity;
  }

  // attribute Nb_Object
  {
    int o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_Nb_Object();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_INT, &o2_entity, 0);
    Nb_Object =  o2_entity;
  }

  // attribute TRef
  {
    Handle o2_entity = 0;
    Scan   *o2_scan;
    int  o2_elem0 = 0;
    int    o2_elem_nb0 = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_TRef();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_CVAL, &o2_entity, 0);
    TRef.resize(o2_col_count(o2_entity));
    o2_scan = o2_col_scan_open(o2_entity, 0);
    while (o2_col_scan_next(o2_scan, &o2_elem0) == OK) {
      
      TRef[o2_elem_nb0] =  o2_elem0;
      o2_elem_nb0++;
      
    }
    o2_col_scan_close(o2_scan);
    o2_unref_handle(o2_entity);
  }

  // attribute CRef
  {
    Handle o2_entity = 0;
    Scan   *o2_scan;
    Handle  o2_elem0 = 0;
    int    o2_elem_nb0 = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_CRef();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_CVAL, &o2_entity, 0);
    CRef.resize(o2_col_count(o2_entity));
    o2_scan = o2_col_scan_open(o2_entity, 0);
    while (o2_col_scan_next(o2_scan, &o2_elem0) == OK) {
      
      CRef[o2_elem_nb0].o2_set_o2p_to_touch(o2_get_o2oo_to_touch());
      CRef[o2_elem_nb0].o2_put_handle(o2_elem0);
      o2_elem_nb0++;
      
    }
    o2_col_scan_close(o2_scan);
    o2_unref_handle(o2_entity);
  }

  // attribute InstanceSize
  {
    int o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_InstanceSize();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_INT, &o2_entity, 0);
    InstanceSize =  o2_entity;
  }

  // attribute Iterator
  {
    Handle o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_Iterator();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_COBJ, &o2_entity, 0);
    Iterator.o2_put_handle(o2_entity);
    Iterator.o2_set_o2oo_to_touch(o2_get_o2oo_to_touch());
    o2_unref_handle(o2_entity);
  }
  
  o2_cplusplus_epilogue(o2_ctx);
}

// ---------------------------------------
//    OCB_Class::o2_write
// ---------------------------------------
void OCB_Class::o2_write() {
  o2ctx o2_ctx = o2_cplusplus_prologue(o2_get_o2oo_handle(), o2cpp_OCB_Class::o2_get_schema());
  
  Handle o2_hd = 0;
  
  
  
  {
    int err;
    if (o2_is_notifiable_object(O2_UPDATE_EVENT, o2_get_o2oo_handle(), &err))
      o2_notify_object_event(O2_UPDATE_EVENT, o2_get_o2oo_handle());
  }
  
  // attribute Id
  {
    
    o2_NewPath_elem o2_path[2];
    int o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_Id();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_hd = o2_get_o2oo_handle();
    o2_entity =  Id;
    o2_put_field(o2_hd, o2_path, O2_INT, &(o2_entity), NV_FLAG, 0);
  }

  // attribute MAXNREF
  {
    
    o2_NewPath_elem o2_path[2];
    int o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_MAXNREF();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_hd = o2_get_o2oo_handle();
    o2_entity =  MAXNREF;
    o2_put_field(o2_hd, o2_path, O2_INT, &(o2_entity), NV_FLAG, 0);
  }

  // attribute BASESIZE
  {
    
    o2_NewPath_elem o2_path[2];
    int o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_BASESIZE();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_hd = o2_get_o2oo_handle();
    o2_entity =  BASESIZE;
    o2_put_field(o2_hd, o2_path, O2_INT, &(o2_entity), NV_FLAG, 0);
  }

  // attribute Nb_Object
  {
    
    o2_NewPath_elem o2_path[2];
    int o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_Nb_Object();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_hd = o2_get_o2oo_handle();
    o2_entity =  Nb_Object;
    o2_put_field(o2_hd, o2_path, O2_INT, &(o2_entity), NV_FLAG, 0);
  }

  // attribute TRef
  {
    Handle o2_entity0 = 0;
    int    o2_elem_nb0;
    o2_NewPath_elem o2_path[2];
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_TRef();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_CVAL, &o2_entity0, 0);
    o2_col_zap(o2_entity0);
    for (o2_elem_nb0 = 0; o2_elem_nb0 < TRef.len(); o2_elem_nb0++) {
      
      int o2_elem = TRef[o2_elem_nb0];
      o2_list_append(o2_entity0, O2_INT, &o2_elem, V_FLAG);
    }
    o2_hd = o2_get_o2oo_handle();
    o2_put_field(o2_hd, o2_path, O2_CVAL, &o2_entity0, NV_FLAG, 0);
  }

  // attribute CRef
  {
    Handle o2_entity0 = 0;
    int    o2_elem_nb0;
    o2_NewPath_elem o2_path[2];
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_CRef();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_CVAL, &o2_entity0, 0);
    o2_col_zap(o2_entity0);
    for (o2_elem_nb0 = 0; o2_elem_nb0 < CRef.len(); o2_elem_nb0++) {
      
      Handle o2_elem = CRef[o2_elem_nb0].o2_get_o2p_lazy();
      o2_list_append(o2_entity0, O2_COBJ, &o2_elem, NV_FLAG);
    }
    o2_hd = o2_get_o2oo_handle();
    o2_put_field(o2_hd, o2_path, O2_CVAL, &o2_entity0, NV_FLAG, 0);
  }

  // attribute InstanceSize
  {
    
    o2_NewPath_elem o2_path[2];
    int o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_InstanceSize();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_hd = o2_get_o2oo_handle();
    o2_entity =  InstanceSize;
    o2_put_field(o2_hd, o2_path, O2_INT, &(o2_entity), NV_FLAG, 0);
  }

  // attribute Iterator
  {
    Handle o2_entity = 0;
    o2_NewPath_elem  o2_path[2];
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_Iterator();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_entity = Iterator.o2_get_o2oo_handle();
    o2_hd = o2_get_o2oo_handle();
    o2_put_field(o2_hd, o2_path, O2_COBJ, &o2_entity, NV_FLAG, 0);
  }
  o2_cplusplus_epilogue(o2_ctx);
}

// ---------------------------------------
//    OCB_Class::o2_diff
// ---------------------------------------
int OCB_Class::o2_diff() {
  o2ctx o2_ctx = o2_cplusplus_prologue(o2_get_o2oo_handle(), o2cpp_OCB_Class::o2_get_schema());
  
  o2_NewPath_elem  o2_path[2];
  int    o2_result = 0;
  
  
  
  // attribute Id
  {
    int o2_entity;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_Id();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_INT, &o2_entity, 0);
    if (Id !=  o2_entity) {
      o2_cplusplus_epilogue(o2_ctx);
      return 1;
    }
  }

  // attribute MAXNREF
  {
    int o2_entity;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_MAXNREF();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_INT, &o2_entity, 0);
    if (MAXNREF !=  o2_entity) {
      o2_cplusplus_epilogue(o2_ctx);
      return 1;
    }
  }

  // attribute BASESIZE
  {
    int o2_entity;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_BASESIZE();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_INT, &o2_entity, 0);
    if (BASESIZE !=  o2_entity) {
      o2_cplusplus_epilogue(o2_ctx);
      return 1;
    }
  }

  // attribute Nb_Object
  {
    int o2_entity;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_Nb_Object();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_INT, &o2_entity, 0);
    if (Nb_Object !=  o2_entity) {
      o2_cplusplus_epilogue(o2_ctx);
      return 1;
    }
  }

  // attribute TRef
  {
    Handle   o2_entity = 0;
    Scan   *o2_scan0;
    int   o2_elem0 = 0;
    int   o2_elem_nb0 = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_TRef();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_CVAL, &o2_entity, 0);
    if (TRef.len() != o2_col_count(o2_entity)) {
      o2_unref_handle(o2_entity);
      o2_cplusplus_epilogue(o2_ctx);
      return 1;
    }
    o2_scan0 = o2_col_scan_open(o2_entity, 0);
    while (o2_col_scan_next(o2_scan0, &o2_elem0) == OK) {
      
      if (TRef[o2_elem_nb0] !=  o2_elem0) {
        o2_col_scan_close(o2_scan0);
        o2_cplusplus_epilogue(o2_ctx);
        return 1;
      }
      o2_elem_nb0++;
    }
    o2_col_scan_close(o2_scan0);
    o2_unref_handle(o2_entity);
  }

  // attribute CRef
  {
    Handle   o2_entity = 0;
    Scan   *o2_scan0;
    Handle   o2_elem0 = 0;
    int   o2_elem_nb0 = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_CRef();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_CVAL, &o2_entity, 0);
    if (CRef.len() != o2_col_count(o2_entity)) {
      o2_unref_handle(o2_entity);
      o2_cplusplus_epilogue(o2_ctx);
      return 1;
    }
    o2_scan0 = o2_col_scan_open(o2_entity, 0);
    while (o2_col_scan_next(o2_scan0, &o2_elem0) == OK) {
      
      if (CRef[o2_elem_nb0].o2_get_o2p_lazy() != o2_elem0) {
        o2_col_scan_close(o2_scan0);
        o2_cplusplus_epilogue(o2_ctx);
        return 1;
      }
      o2_elem_nb0++;
    }
    o2_col_scan_close(o2_scan0);
    o2_unref_handle(o2_entity);
  }

  // attribute InstanceSize
  {
    int o2_entity;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_InstanceSize();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_INT, &o2_entity, 0);
    if (InstanceSize !=  o2_entity) {
      o2_cplusplus_epilogue(o2_ctx);
      return 1;
    }
  }

  // attribute Iterator
  {
    Handle o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Class::o2_get_pid_Iterator();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_COBJ, &o2_entity, 0);
    if (Iterator.o2_get_o2oo_handle() != o2_entity) {
      o2_unref_handle(o2_entity);
      o2_cplusplus_epilogue(o2_ctx);
      return 1;
    }
    o2_unref_handle(o2_entity);
  }
  o2_cplusplus_epilogue(o2_ctx);
  return o2_result;
}

// ---------------------------------------
//    OCB_Class::o2_release
// ---------------------------------------
void OCB_Class::o2_release() {
  
}

// ---------------------------------------
//    OCB_Class::o2_write_if_diff
// ---------------------------------------
int OCB_Class::o2_write_if_diff() {
  
  
  
  return 0;
}

// ---------------------------------------
//    OCB_Class::o2_get_name
// ---------------------------------------
char* OCB_Class::o2_get_name() {
  
  return "OCB_Class";
}

// ---------------------------------------
//    OCB_Class::o2_get_class_id
// ---------------------------------------
Handle OCB_Class::o2_get_class_id() {
  
  return o2cpp_OCB_Class::o2_get_class_id();
}
