/////////////////////////////////////////////////////////////////////
// OCB (the Object Clustering Benchmark)
// Version 1.0 OCB/O2, janvier 1999
// Fromantin Christophe
// LIMOS, Blaise Pascal University (Clermont-Ferrand II), France
/////////////////////////////////////////////////////////////////////
// OCB_classes_O2.hxx: O2 classes definition
/////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////
// CLASS OCB_db_O2
/////////////////////////////////////////////////////////////////////

class OCB_db_O2 {

  public:

    
     d_Session     O2_Session;
     d_Transaction O2_Transaction;
     d_Database    O2_Database;
    
    // Public attributes
    // Statistical counters
    int NSet;                           // Number of set-oriented accesses
    int NOSet;                          // and number of accessed objects
    int NSim;                           // Number of simple traversals
    int NOSim;                          // and number of accessed objects 
    int NHie;                           // Number of hierarchy traversals
    int NOHie;                          // and number of accessed objects 
    int NSto;                           // Number of stochastic traversals
    int NOSto;                          // and number of accessed objects

    // Methods
    void Generation(OCB_db_O2 *);       // Database generation
    void RunTransaction(short Stats);   // Database usage
    void ResetStats();                  // Set stats to 0
    void DisplayStats();                // Display stats


    // Methods

    OCB_db_O2(int,char **);           // Constructor
    ~OCB_db_O2();                     // Destructor   
    void Create_Database_O2();           
    void Open_Database_O2();             
    void Close_Database_O2();            
    void Create_Class_Object_O2();
    void Reset_Stat_O2();
    void Display_Stat_O2();

  private:

    // Private attributes
    short NoCycle[MNTR];              // Cyclic hierarchy flag
    short Inheritance[MNTR];          // Inheritance hierarchy flag

    // Internal methods
    // Set-oriented acces
    void SetOrientedAccess(const d_Ref<OCB_Object> &Root,int Depth,short Stats);
    // Simple traversals
    void SimpleTraversal(const d_Ref<OCB_Object>  &Root,int CurDepth,int Depth,short Stats);
    // Hierarchy traversals
    void HierarchyTraversal(const d_Ref<OCB_Object> &Root,int CurDepth,int Depth,int RefType,short Stats);
    // Stochastic traversals
    void StochasticTraversal(const d_Ref<OCB_Object> &Root,int Depth,short Stats);

};

