/////////////////////////////////////////////////////////////////////
// OCB (the Object Clustering Benchmark)
// Version 1.0 OCB/O2, Janvier 1999
// Fromantin Christophe
// LIMOS, Blaise Pascal University (Clermont-Ferrand II), France
/////////////////////////////////////////////////////////////////////
// OCB_Methods_O2.cc: Methods for persistence definition
/////////////////////////////////////////////////////////////////////
#include<o2.h>

/////////////////////////////////////////////////////////////////////
// CLASS OCB_db_O2
/////////////////////////////////////////////////////////////////////

// CLASS OCB_db_O2: Constructor
 OCB_db_O2::OCB_db_O2(int narg,char *carg[]) {

 // connection to the o2 database
    O2_Session.set_default_env();

 //O2_Session.set_swapdir("/home/o2/swap");

    if (O2_Session.begin(narg, carg))
    {
       cerr << "Something wrong to start o2" << endl;
       exit(1);
    }
 }


// CLASS Database: Destructor
 OCB_db_O2::~OCB_db_O2() { 

     Display_Stat_O2(); // O2 stats display
     O2_Session.end();  // Disconnection

 }

 void OCB_db_O2::Create_Database_O2() {

    O2_Transaction.begin();
    o2_VolDesc* name_vol;
    //name_vol = O2_Database.get_volume_descriptor("v_OCB");

    name_vol = O2_Database.get_volume_descriptor("myvolume");
    O2_Database.set_default_vol(name_vol); 
    O2_Database.destroy("OCB");

    //O2_Database.destroy_persistent_root("Les_Classes");
    //O2_Database.destroy_persistent_root("Les_Objets");
    //O2_Database.create("OCB","s_OCB","v_OCB",65,95);

    O2_Database.create("OCB","s_OCB","myvolume",65,95);
    O2_Transaction.commit();
 
 }

 void OCB_db_O2::Open_Database_O2() {

    d_Database    O2_Database;
    O2_Database.open("OCB");
    Reset_Stat_O2();

 }
 void OCB_db_O2::Close_Database_O2() {
    
    O2_Database.close();

 }


 void OCB_db_O2::Create_Class_Object_O2() {

    O2_Transaction.begin();
 
    //O2_Database.create_persistent_root("Les_Classes","d_List<d_Ref<OCB_Class> >",OL_CONSTANT);
    //O2_Database.create_persistent_root("Les_Objets","d_List<d_Ref<OCB_Object> >",OL_CONSTANT);
    
    // Class processing

    int ii,jj,kk,ll,mm,count;
    short pb;
    short NoCycle[MNTR],Inheritance[MNTR];
    NoCycle[0]=1;
    Inheritance[0]=1;

    for (ii=1; ii<NREFT; ii++) {
        NoCycle[ii] =0;
        Inheritance[ii]=0;}

    OCB_Class::Restart_Class(0);
    OCB_Class::Clear_Class();

    d_Ref<OCB_Class> La_Classe;
    d_Ref<OCB_Class> La_Classe_de_la_Classe;

   
// Step #1: Classes

    for (ii=0; ii<NC; ii++)
    {
       La_Classe = new OCB_Class(); 
       La_Classe->Insert_Class(La_Classe,ii,MAXNREF,BASESIZE);
    }


// Step #2: Inter-class links

    for (ii=0;ii<NC;ii++)
    { 
      
      OCB_Class::Read_Class(La_Classe,ii);

      La_Classe->CRef.resize(MAXNREF);
      for (jj=0;jj<MAXNREF;jj++)
      { 
          kk=Rand(INFCLASS-1,SUPCLASS-1,DIST2);
          OCB_Class::Read_Class(La_Classe_de_la_Classe,kk);
          La_Classe->CRef[jj].clear();
          La_Classe->CRef[jj] = La_Classe_de_la_Classe;
       }

       La_Classe->Replace_Class(La_Classe,ii);
    }


// Step #3: Acyclic graphs consistency

    d_List<d_Ref<OCB_Class> > Pile_Classe;

    for (ii=0;ii<NC;ii++)
    { 
      
      OCB_Class::Read_Class(La_Classe,ii);
      for (jj=0;jj<MAXNREF;jj++)
      { 
          if ((NoCycle[La_Classe->TRef[jj]])
          && (La_Classe->CRef[jj] != (const d_Ref<OCB_Class>*) (0))){
              Pile_Classe.insert_element_last(La_Classe->CRef[jj]);
              count=0;
              pb=0;
              while ((!Pile_Classe.is_empty())  && (!pb) ){
                    La_Classe_de_la_Classe= Pile_Classe.retrieve_last_element();
                    Pile_Classe.remove_last_element();
                    count++;
                    if ((La_Classe_de_la_Classe->Id == La_Classe->Id) || (count>NC))
                       pb=1;
                    else
                    for(kk=0; kk<MAXNREF; kk++) 
                       if ((La_Classe_de_la_Classe->TRef[kk]==La_Classe->TRef[jj]) 
                          && (La_Classe_de_la_Classe->CRef[kk] != (const d_Ref<OCB_Class>*) (0))){
                          Pile_Classe.insert_element_last(La_Classe_de_la_Classe->CRef[kk]);
                    }}
              Pile_Classe.remove_all();
              if (pb) La_Classe->CRef[jj].clear();    
              else if (Inheritance[La_Classe->TRef[jj]]) {
                      Pile_Classe.insert_element_last(La_Classe->CRef[jj]);
                      while(!Pile_Classe.is_empty()) {
                      La_Classe_de_la_Classe= Pile_Classe.retrieve_last_element();
                      Pile_Classe.remove_last_element();
                      La_Classe_de_la_Classe->InstanceSize=La_Classe_de_la_Classe->InstanceSize+La_Classe->BASESIZE;
                      La_Classe->Replace_Class(La_Classe_de_la_Classe,La_Classe_de_la_Classe->Id);
                      for(kk=0; kk<MAXNREF; kk++)
                         if ((La_Classe_de_la_Classe->TRef[kk]==La_Classe->TRef[jj]) 
                            && (La_Classe_de_la_Classe->CRef[kk] != (const d_Ref<OCB_Class>*) (0))){
                            Pile_Classe.insert_element_last(La_Classe_de_la_Classe->CRef[kk]);
                      }}
              Pile_Classe.remove_all();
              }
          }
      } 
     }


// Step #4: Instances

    OCB_Object::Restart_Object(0);
    OCB_Object::Clear_Object();
    d_Ref<OCB_Object> L_Objet;
    
    for (ii=0; ii<NO; ii++) {      
         L_Objet = new OCB_Object();
         OCB_Object::Insert_Object(L_Objet,ii);
        }  
 
 
// Step #5: Inter-object links

    int nb_count;
    d_Ref<OCB_Object> L_Objet_Null;
    L_Objet_Null.clear();
    nb_count = 0;            
    for (ii=0;ii<NC;ii++)
    { 
       OCB_Class::Read_Class(La_Classe,ii);
       count ++;
       for (jj=0; jj<La_Classe->Nb_Object;jj++) 
           for (kk=0; kk<MAXNREF; kk++)
           if (La_Classe->CRef[kk] != (const d_Ref<OCB_Class>*) (0)){
               La_Classe_de_la_Classe = La_Classe->CRef[kk];
               if (La_Classe_de_la_Classe->Nb_Object> 0) {
               ll= Rand(0,La_Classe_de_la_Classe->Nb_Object-1,DIST4);
               L_Objet = La_Classe_de_la_Classe->Iterator[ll];
               //La_Classe->Iterator[jj]->ORef[kk] = L_Objet;
               La_Classe->Iterator[jj]->ORef.insert_element(L_Objet);
               L_Objet->BackRefList.insert_element(La_Classe->Iterator[jj]);}
                }
               else 
                   La_Classe->Iterator[jj]->ORef.insert_element(L_Objet_Null);
     }

    Nb_Filler=0;

    for (ii=0; ii<NO; ii++) {      
         OCB_Object::Read_Object(L_Objet,ii);
         OCB_Object::Update_Object(L_Objet);
         nb_count++;
        }  
 
    printf("\n\tNombre de Filler =%d",Nb_Filler);

    O2_Transaction.commit();  // OCB database generation validation 

 } 

 void OCB_db_O2::Reset_Stat_O2() { 
    o2_reset_stat(O2_ALL); // Stats reinitialization
 }

 void OCB_db_O2::Display_Stat_O2() { 

    o2_ClientStat Cstat;
    o2_ServerStat Sstat;
    Base_stat *Vstat;

    o2_server_stat(&Sstat);
    o2_client_stat(&Cstat);
    Vstat= o2_base_stat("OCB");  
 
    printf("\n\tCache satistics Serveur (in 4Kb pages)");
    printf("\n\tSize :=%u KB",Sstat.buffSize );
    printf("\n\tFill Rate :=%u [max=%u]",Sstat.buffFillRate,Sstat.buffMaxFill);
    printf("\n\tRead :=%u Write :=%u",Sstat.ioNbRead,Sstat.ioNbWrite);
    printf("\n\n\tCache satistics Client (in 4Kb pages)");
    printf("\n\tSize :=%u KB",Cstat.buffSize );
    printf("\n\tFill Rate :=%u [max=%u]",Cstat.buffFillRate,Cstat.buffMaxFill);
    printf("\n\tRead :=%u Write :=%u",Cstat.ioNbRead,Cstat.ioNbWrite,"\n");
    printf("\n\tBase size :=%d Kb",Vstat->size);

    printf("\n\n\tMemory statistics Client (O2SWAPSIZE)");
    printf("\n\tAllocation limit :=%u File Swap :=%u",Cstat.memMallocLimit,Cstat.memSwapped);

    printf("\n");

 } 

// CLASS Database: Transaction execution (database usage)

void OCB_db_O2::RunTransaction(short Stats) {

  float var;
  int type;
  int n;

   d_Ref<OCB_Object> L_Objet;
   
// Root object random selection
   n = Rand(0,NO-1,DIST5);
   OCB_Object::Read_Object(L_Objet,n);
   
// Transaction type random selection
// Call to randu()

  var=randu(lp_tt);
  if (var<=PSET) type=1;                        // Set-oriented access
  else if (var<=(PSET+PSIMPLE)) type=2;         // Simple traversal
  else if (var<=(PSET+PSIMPLE+PHIER)) type=3;   // Hierarchy traversal
  else type=4;                                  // Stochastic traversal


// Transaction execution by type
    
  switch (type) {
    case 1: {                           // Set-oriented access
      SetOrientedAccess(L_Objet,SETDEPTH,Stats);
      NSet++;
      break;
      }
    case 2: {                           // Simple traversal
      SimpleTraversal(L_Objet,1,SIMDEPTH,Stats);
      NSim++;
      break;
      }
    case 3: {                           // Hierarchy traversal
      HierarchyTraversal(L_Objet,1,HIEDEPTH,Rand(0,NREFT-1,DUNI),Stats);
      NHie++;
      break;
      }
    case 4: {                           // Stochastic traversal
      StochasticTraversal(L_Objet,STODEPTH,Stats);
      NSto++;
      break;
      }
    }
   if (Stats) sleep(THINK);

}

// CLASS Database: Set-oriented access

void OCB_db_O2::SetOrientedAccess(const d_Ref<OCB_Object> &Root,int Depth,short Stats) {

  d_Ref<OCB_Object> Cur;                // Current object
  d_Array<d_Ref<OCB_Object> >ToExplore;
  int NbToEx;                           // Objects to access queue
  int Prof[TTO]; int NbP;               // Depth queue
  int CurDepth;                         // Current depth
  int i,num;
  ToExplore.resize(TTO);  
      
  // Traversal initialization

  ToExplore[0]=Root;NbToEx=1;
  Prof[0]=1;NbP=1;

  while (NbToEx>0)  {

    // queue out
    Cur=ToExplore[0];
    for (i=0; i<NbToEx-1; i++) ToExplore[i]=ToExplore[i+1];
    NbToEx--;
    OCB_Object::Read_Object_Comp(Cur);
    num = Cur->Id + 1;
        
    NOSet++;
    CurDepth=Prof[0];
    for (i=0; i<NbP-1; i++) Prof[i]=Prof[i+1];
    NbP--;

    if (CurDepth<Depth) {
      for (i=0; i<MAXNREF; i++) {
          if (Cur->ORef[i] !=(const d_Ref<OCB_Object>*)(0)) {
             ToExplore[NbToEx++]=Cur->ORef[i];
             Prof[NbP++]=CurDepth+1;
             }
      }
    }
 }
}

// CLASS Database: Simple traversal

void OCB_db_O2::SimpleTraversal(const d_Ref<OCB_Object> &Root,int CurDepth,int Depth,short Stats) {

  int i;
  d_Ref<OCB_Object> Cur;                 // Current object

  Cur =Root;
  OCB_Object::Read_Object_Comp(Cur);

  NOSim++;
  if (CurDepth<Depth) {                 // Resume traversal
    for (i=0; i<MAXNREF; i++) {         // Scan all references
      if (Root->ORef[i] !=(const d_Ref<OCB_Object>*)(0)) {

        Cur = Root->ORef[i];
        SimpleTraversal(Cur,CurDepth+1,Depth,Stats);
        }
      }
    }
}

// CLASS Database: Hierarchy traversal

void OCB_db_O2::HierarchyTraversal(const d_Ref<OCB_Object>  &Root,int CurDepth,int Depth,int RefType,short Stats) {

  int i;

  d_Ref<OCB_Object> Cur;                          // Current object
  Cur = Root;
  OCB_Object::Read_Object_Comp(Cur);
  NOHie++;
  if (CurDepth<Depth) {                          // Resume traversal
      for (i=0; i<MAXNREF; i++) {
      if ((Root->ORef[i] !=(const d_Ref<OCB_Object>*)(0)) 
        && (Root->ClassPtr->TRef[i]==RefType)) { // +right type
        Cur = Root->ORef[i];
        HierarchyTraversal(Cur,CurDepth+1,Depth,RefType,Stats);
        }
      }
    }
}

// CLASS Database: Stochastic traversal

void OCB_db_O2::StochasticTraversal(const d_Ref<OCB_Object> &Root,int Depth,short Stats) {

  d_Ref<OCB_Object> Cur;                // Current object
  int CurDepth;                         // Current depth
  float alea;                           // Random roll
  float stochtab[MNR];                  // Probability table
  int i,j;

  CurDepth=1;
  Cur=Root;
  while (CurDepth<=Depth) {
    OCB_Object::Read_Object_Comp(Cur);
    NOSto++;

    // Stochtab computation
    alea=2;
    stochtab[0]=1/alea;
    //for (i=1; i<Cur->ClassPtr->MAXNREF; i++) {
    for (i=1; i<MAXNREF; i++) {
      alea=alea*2;
      stochtab[i]=stochtab[i-1]+(1/alea);
      }

    // Random roll
    alea=randu(lp_tt);
    // Test of the relationship to follow (i)
    i=0;j=-1; // j is a flag
    //while ((i<Cur->ClassPtr->MAXNREF) && (j<0)) {
    while ((i<MAXNREF) && (j<0)) {
      if (alea>stochtab[i]) i++;
      else j=1;
    }
    if (j==1) { // Relationship found
      if (Cur->ORef[i] !=(const d_Ref<OCB_Object>*)(0)) {
        Cur=Cur->ORef[i];
        CurDepth++;
      } else CurDepth=Depth+1;
    } else CurDepth=Depth+1;
  }
}

// CLASS Database: Reinitialization of the statistic counters

void OCB_db_O2::ResetStats() {

  NSet=0;
  NOSet=0;
  NSim=0;
  NOSim=0;
  NHie=0;
  NOHie=0;
  NSto=0;
  NOSto=0;
}

// CLASS Database: Display of the statistic counters

void OCB_db_O2::DisplayStats() {

  printf("\nAccess type\t\t#Accesses\t#Objects\t#Objects (avg)\n");
  printf("----------------------------------------------------------------------\n");
  printf("Set-oriented access\t%d\t\t%d\t\t%f\n",NSet,NOSet,1.*NOSet/NSet);
  printf("Simple traversal\t%d\t\t%d\t\t%f\n",NSim,NOSim,1.*NOSim/NSim);
  printf("Hierarchy traversal\t%d\t\t%d\t\t%f\n",NHie,NOHie,1.*NOHie/NHie);
  printf("Stochastic traversal\t%d\t\t%d\t\t%f\n",NSto,NOSto,1.*NOSto/NSto);
  printf("----------------------------------------------------------------------\n");
  printf("TOTAL\t\t\t%d\t\t%d\t\t%f\n",NSet+NSim+NHie+NSto,NOSet+NOSim+NOHie+NOSto,
    1.*(NOSet+NOSim+NOHie+NOSto)/(NSet+NSim+NHie+NSto));
}

