
/////////////////////////////////////////////////////////////////////
// OCB (the Object Clustering Benchmark)
// Version 1.0 OCB/O2, janvier 1999
// Fromantin Christophe
// LIMOS, Blaise Pascal University (Clermont-Ferrand II), France
/////////////////////////////////////////////////////////////////////
// ocb.hh: Constants and global variables definition
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
// CONSTANTS
/////////////////////////////////////////////////////////////////////

#define MNR  10    // Maximum number of references
#define MNTR 10    // Maximum number of reference types
#define NOO 50000  // Maximum number of objets in object lists
#define TTO 500    // Object sub-tables size
#define NOC 50     // Maximum number of classes in class lists
#define TUR 44     // Filling units size
                   // Units real size UR = TUR + ~ 4-6 bytes

#define DUNI    1  // Uniform random distribution code
#define DNORM   2  // Normal random distribution code
#define NOSTATS 0  // Statistics collect OFF code
#define STATS   1  // Statistics collect ON code

#define MAXPATHLEN 255 // Filename max size

/////////////////////////////////////////////////////////////////////
// OCB parameters (+ default values)
/////////////////////////////////////////////////////////////////////

// Parameters defining the database

int NC=20;              // Number of classes
int MAXNREF=10;         // Max. number of references, per class
int BASESIZE=50;        // Instances base size, per class
int NO=1000;            // Total number of objects
int NREFT=4;            // Number of reference types
int INFCLASS=1;         // Inf. bound of the set of referenced classes
int SUPCLASS=NC;        // Sup. bound of the set of referenced classes
int INFREF=1;           // Inf. bound of the set of referenced objects
int SUPREF=NO;          // Sup. bound of the set of referenced objects
int DIST1=DUNI;         // Reference types random distribution
int DIST2=DUNI;         // Class references random distribution
int DIST3=DUNI;         // Objects in classes random distribution
int DIST4=DUNI;         // Referenced objects random distribution

// Parameters defining the transactions

int SETDEPTH=3;         // Set-oriented access depth
int SIMDEPTH=3;         // Simple traversals depth
int HIEDEPTH=5;         // Hierarchy traversals depth
int STODEPTH=50;        // Stochastic traversals depth
int COLDN=1000;         // Cold run number of transactions
int HOTN=10000;         // Warm run number of transactions
int THINK=0;            // Mean latency time between two transactions
float PSET=0.25;        // Set-oriented access occurence probability
float PSIMPLE=0.25;     // Simple traversal access occurence probability
float PHIER=0.25;       // Hierarchy traversal access occurence probability
float PSTOCH=0.25;      // Stochastic traversal access occurence probability
int DIST5=DUNI;         // Transactions root objects distribution
int CLIENTN=1;          // Number of clients
int RSEED=-1;           // Random seed
int Object_Size = 50;   // Object initial size
int Nb_Filler = 0;      // Number of fillers in the database
