/*
// This file has been patched in order to use the O2 database
// on Wed Jun  9 09:27:42 1999
*/


/////////////////////////////////////////////////////////////////////
// OCB (the Object Clustering Benchmark)
// Version 1.0 OCB/O2, janvier 1999
// Fromantin Christophe
// LIMOS, Blaise Pascal University (Clermont-Ferrand II), France
/////////////////////////////////////////////////////////////////////
// OCB_Object.hh: Classe "Object" definition
/////////////////////////////////////////////////////////////////////

class OCB_Class;

/////////////////////////////////////////////////////////////////////
// CLASS Object
/////////////////////////////////////////////////////////////////////


#ifndef __ODMG_93__   // patch of class OCB_Object
class OCB_Object {

  public:

    // Public attributes
    int Id;
    d_Ref<OCB_Class >  ClassPtr;
    d_List<d_Ref<OCB_Object >  > ORef;
    d_Bag<d_Ref<OCB_Object >  > BackRefList;
    d_List<char *> Filler;
    

    OCB_Object()  ;        // Constructor

    static d_List<d_Ref<OCB_Object> > *Les_Objets;
    static void Restart_Object(int);
    static void Clear_Object(); 
    static void Read_Object(d_Ref<OCB_Object> &,int); 
    static void Read_Object_Comp(d_Ref<OCB_Object> &); 
    static void Insert_Object(d_Ref<OCB_Object> &,int); 
    static void Update_Object(d_Ref<OCB_Object> &); 
    static void Replace_Object(d_Ref<OCB_Object>,int);  
};
#else                 // patch of class OCB_Object
#include "o2_root_defs.hxx"
class OCB_Object : public virtual o2_root {

  public:

    // Public attributes
    int Id;
    d_Ref<OCB_Class >  ClassPtr;
    d_List<d_Ref<OCB_Object >  > ORef;
    d_Bag<d_Ref<OCB_Object >  > BackRefList;
    d_List<char *> Filler;

    
    OCB_Object()  ;        // Constructor

    static d_List<d_Ref<OCB_Object> > *Les_Objets;
    static void Restart_Object(int);
    static void Clear_Object(); 
    static void Read_Object(d_Ref<OCB_Object> &,int); 
    static void Read_Object_Comp(d_Ref<OCB_Object> &); 
    static void Select_Object(d_Ref<OCB_Object> &,int); 
    static void Insert_Object(d_Ref<OCB_Object> &,int); 
    static void Update_Object(d_Ref<OCB_Object> &); 
    static void Replace_Object(d_Ref<OCB_Object>,int);  

protected:
    virtual void   o2_new();
    virtual void   o2_read();
    virtual void   o2_release();
    virtual int    o2_diff();
    virtual void   o2_write();
    virtual int    o2_write_if_diff();
public:
    virtual void*  o2_get_ref() { return this; };
    static  Handle o2_get_class_id();
    static  char*  o2_get_name();
    OCB_Object(o2_Shadow, Handle);
};
#endif                // patch of class OCB_Object


