//
// Copyright (c) 1999 O2Technology. All Rights Reserved
//

// ---------------------------------------
// Include Files
// ---------------------------------------
#include <stdlib.h>
#include "o2_root_defs.hxx"
#include "o2_notification.h"
#include "OCB_Object.hxx"

#include "o2_macros.h"
#ifdef O2_NEED_TMPL_SRC
#include "o2template_CC.cc"
#endif 

// ---------------------------------------
// Global Declarations
// ---------------------------------------
class o2cpp_OCB_Object {
  private:
    static Handle hd;
    static unsigned short trans_nb;
    static o2schema s;
    static Pid att_Id;
    static Pid att_ClassPtr;
    static Pid att_ORef;
    static Pid att_BackRefList;
    static Pid att_Filler;
    
  public:
    
    static Pid o2_get_pid_Id() {
      if (!att_Id){
        Sm_meta_prop kind;
        o2_name_to_pid(o2_get_class_id(), "Id", &att_Id, &kind);
      }
      return att_Id;
    }

    static Pid o2_get_pid_ClassPtr() {
      if (!att_ClassPtr){
        Sm_meta_prop kind;
        o2_name_to_pid(o2_get_class_id(), "ClassPtr", &att_ClassPtr, &kind);
      }
      return att_ClassPtr;
    }

    static Pid o2_get_pid_ORef() {
      if (!att_ORef){
        Sm_meta_prop kind;
        o2_name_to_pid(o2_get_class_id(), "ORef", &att_ORef, &kind);
      }
      return att_ORef;
    }

    static Pid o2_get_pid_BackRefList() {
      if (!att_BackRefList){
        Sm_meta_prop kind;
        o2_name_to_pid(o2_get_class_id(), "BackRefList", &att_BackRefList, &kind);
      }
      return att_BackRefList;
    }

    static Pid o2_get_pid_Filler() {
      if (!att_Filler){
        Sm_meta_prop kind;
        o2_name_to_pid(o2_get_class_id(), "Filler", &att_Filler, &kind);
      }
      return att_Filler;
    }
    static Handle o2_get_class_id() {
      if (trans_nb <= __o2_switch_commit) {
        trans_nb = __o2_switch;
        hd = 0;
      }
      if (!hd)
        hd = o2_exec_id("OCB_Object", O2_CLASS);
        if(!hd) rt_error_class("OCB_Object");
      return hd;
    }
    static o2schema o2_get_schema() {
      if(!s) s = o2_open_schema("s_OCB");
      return s;
    }
};

// ---------------------------------------
// Initialization of static members of the class o2cpp_OCB_Object
// ---------------------------------------
Handle o2cpp_OCB_Object::hd = 0;
unsigned short o2cpp_OCB_Object::trans_nb = __o2_switch;
o2schema o2cpp_OCB_Object::s = 0;
Pid o2cpp_OCB_Object::att_Id = 0;
Pid o2cpp_OCB_Object::att_ClassPtr = 0;
Pid o2cpp_OCB_Object::att_ORef = 0;
Pid o2cpp_OCB_Object::att_BackRefList = 0;
Pid o2cpp_OCB_Object::att_Filler = 0;

// ---------------------------------------
//    Functions for late-binding
// ---------------------------------------

extern "C" {
  OCB_Object *o2_OCB_Object_ctr_OCB_Object(Handle);
}

OCB_Object *o2_OCB_Object_ctr_OCB_Object(Handle hd) {
  OCB_Object *r = new OCB_Object((o2_Shadow)0, hd);
  return r;
}

// ---------------------------------------
//    Constructor
// ---------------------------------------
OCB_Object::OCB_Object(o2_Shadow shad, Handle hd) : ORef(shad),BackRefList(shad),Filler(shad) {
  Handle tmp_hd = hd;
  shad = 0;
}

// ---------------------------------------
//    OCB_Object::o2_new
// ---------------------------------------
void OCB_Object::o2_new() {
  o2_create_object(o2cpp_OCB_Object::o2_get_class_id());
}

// ---------------------------------------
//    OCB_Object::o2_read
// ---------------------------------------
void OCB_Object::o2_read() {
  o2ctx o2_ctx = o2_cplusplus_prologue(o2_get_o2oo_handle(), o2cpp_OCB_Object::o2_get_schema());
  
  o2_NewPath_elem o2_path[2];
  
  
  
  // attribute Id
  {
    int o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Object::o2_get_pid_Id();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_INT, &o2_entity, 0);
    Id =  o2_entity;
  }

  // attribute ClassPtr
  {
    Handle o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Object::o2_get_pid_ClassPtr();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_COBJ, &o2_entity, 0);
    ClassPtr.o2_set_o2p_to_touch(o2_get_o2oo_to_touch());
    ClassPtr.o2_put_handle(o2_entity);
    o2_unref_handle(o2_entity);
  }

  // attribute ORef
  {
    Handle o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Object::o2_get_pid_ORef();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_COBJ, &o2_entity, 0);
    ORef.o2_put_handle(o2_entity);
    ORef.o2_set_o2oo_to_touch(o2_get_o2oo_to_touch());
    o2_unref_handle(o2_entity);
  }

  // attribute BackRefList
  {
    Handle o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Object::o2_get_pid_BackRefList();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_COBJ, &o2_entity, 0);
    BackRefList.o2_put_handle(o2_entity);
    BackRefList.o2_set_o2oo_to_touch(o2_get_o2oo_to_touch());
    o2_unref_handle(o2_entity);
  }

  // attribute Filler
  {
    Handle o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Object::o2_get_pid_Filler();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_COBJ, &o2_entity, 0);
    Filler.o2_put_handle(o2_entity);
    Filler.o2_set_o2oo_to_touch(o2_get_o2oo_to_touch());
    o2_unref_handle(o2_entity);
  }
  
  o2_cplusplus_epilogue(o2_ctx);
}

// ---------------------------------------
//    OCB_Object::o2_write
// ---------------------------------------
void OCB_Object::o2_write() {
  o2ctx o2_ctx = o2_cplusplus_prologue(o2_get_o2oo_handle(), o2cpp_OCB_Object::o2_get_schema());
  
  Handle o2_hd = 0;
  
  
  
  {
    int err;
    if (o2_is_notifiable_object(O2_UPDATE_EVENT, o2_get_o2oo_handle(), &err))
      o2_notify_object_event(O2_UPDATE_EVENT, o2_get_o2oo_handle());
  }
  
  // attribute Id
  {
    
    o2_NewPath_elem o2_path[2];
    int o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Object::o2_get_pid_Id();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_hd = o2_get_o2oo_handle();
    o2_entity =  Id;
    o2_put_field(o2_hd, o2_path, O2_INT, &(o2_entity), NV_FLAG, 0);
  }

  // attribute ClassPtr
  {
    Handle o2_entity = 0;
    o2_NewPath_elem  o2_path[2];
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Object::o2_get_pid_ClassPtr();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_entity = ClassPtr.o2_get_o2p_lazy();
    o2_hd = o2_get_o2oo_handle();
    o2_put_field(o2_hd, o2_path, O2_COBJ, &o2_entity, NV_FLAG, 0);
  }

  // attribute ORef
  {
    Handle o2_entity = 0;
    o2_NewPath_elem  o2_path[2];
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Object::o2_get_pid_ORef();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_entity = ORef.o2_get_o2oo_handle();
    o2_hd = o2_get_o2oo_handle();
    o2_put_field(o2_hd, o2_path, O2_COBJ, &o2_entity, NV_FLAG, 0);
  }

  // attribute BackRefList
  {
    Handle o2_entity = 0;
    o2_NewPath_elem  o2_path[2];
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Object::o2_get_pid_BackRefList();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_entity = BackRefList.o2_get_o2oo_handle();
    o2_hd = o2_get_o2oo_handle();
    o2_put_field(o2_hd, o2_path, O2_COBJ, &o2_entity, NV_FLAG, 0);
  }

  // attribute Filler
  {
    Handle o2_entity = 0;
    o2_NewPath_elem  o2_path[2];
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Object::o2_get_pid_Filler();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_entity = Filler.o2_get_o2oo_handle();
    o2_hd = o2_get_o2oo_handle();
    o2_put_field(o2_hd, o2_path, O2_COBJ, &o2_entity, NV_FLAG, 0);
  }
  o2_cplusplus_epilogue(o2_ctx);
}

// ---------------------------------------
//    OCB_Object::o2_diff
// ---------------------------------------
int OCB_Object::o2_diff() {
  o2ctx o2_ctx = o2_cplusplus_prologue(o2_get_o2oo_handle(), o2cpp_OCB_Object::o2_get_schema());
  
  o2_NewPath_elem  o2_path[2];
  int    o2_result = 0;
  
  
  
  // attribute Id
  {
    int o2_entity;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Object::o2_get_pid_Id();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_INT, &o2_entity, 0);
    if (Id !=  o2_entity) {
      o2_cplusplus_epilogue(o2_ctx);
      return 1;
    }
  }

  // attribute ClassPtr
  {
    Handle o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Object::o2_get_pid_ClassPtr();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_COBJ, &o2_entity, 0);
    if (ClassPtr.o2_get_o2p_lazy() != o2_entity) {
      o2_unref_handle(o2_entity);
      o2_cplusplus_epilogue(o2_ctx);
      return 1;
    }
    o2_unref_handle(o2_entity);
  }

  // attribute ORef
  {
    Handle o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Object::o2_get_pid_ORef();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_COBJ, &o2_entity, 0);
    if (ORef.o2_get_o2oo_handle() != o2_entity) {
      o2_unref_handle(o2_entity);
      o2_cplusplus_epilogue(o2_ctx);
      return 1;
    }
    o2_unref_handle(o2_entity);
  }

  // attribute BackRefList
  {
    Handle o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Object::o2_get_pid_BackRefList();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_COBJ, &o2_entity, 0);
    if (BackRefList.o2_get_o2oo_handle() != o2_entity) {
      o2_unref_handle(o2_entity);
      o2_cplusplus_epilogue(o2_ctx);
      return 1;
    }
    o2_unref_handle(o2_entity);
  }

  // attribute Filler
  {
    Handle o2_entity = 0;
    
    o2_path[0].kind_elem = O2_PATH_OFID;
    o2_path[0].path_elem.elem_pid.pid = o2cpp_OCB_Object::o2_get_pid_Filler();
    o2_path[1].kind_elem = O2_PATH_END;
    
    o2_get_field(o2_get_o2oo_handle(), o2_path, O2_COBJ, &o2_entity, 0);
    if (Filler.o2_get_o2oo_handle() != o2_entity) {
      o2_unref_handle(o2_entity);
      o2_cplusplus_epilogue(o2_ctx);
      return 1;
    }
    o2_unref_handle(o2_entity);
  }
  o2_cplusplus_epilogue(o2_ctx);
  return o2_result;
}

// ---------------------------------------
//    OCB_Object::o2_release
// ---------------------------------------
void OCB_Object::o2_release() {
  
}

// ---------------------------------------
//    OCB_Object::o2_write_if_diff
// ---------------------------------------
int OCB_Object::o2_write_if_diff() {
  
  
  
  return 0;
}

// ---------------------------------------
//    OCB_Object::o2_get_name
// ---------------------------------------
char* OCB_Object::o2_get_name() {
  
  return "OCB_Object";
}

// ---------------------------------------
//    OCB_Object::o2_get_class_id
// ---------------------------------------
Handle OCB_Object::o2_get_class_id() {
  
  return o2cpp_OCB_Object::o2_get_class_id();
}
