
/////////////////////////////////////////////////////////////////////
// OCB (the Object Clustering Benchmark)
// Version 1.0 OCB/O2, janvier 1999
// Fromantin Christophe
// LIMOS, Blaise Pascal University (Clermont-Ferrand II), France
/////////////////////////////////////////////////////////////////////
// ocbutil.hh: Utilitary functions
/////////////////////////////////////////////////////////////////////
// void Randomize(long Seed)
// int Rand(int Min,int Max,int Distribution)
// long GetIO()
/////////////////////////////////////////////////////////////////////

#include<sys/time.h>
#include<sys/resource.h>
#include<unistd.h>
#include "Lewis_Payne.h"

/////////////////////////////////////////////////////////////////////
// Randomize
/////////////////////////////////////////////////////////////////////
// Random seed initialization
/////////////////////////////////////////////////////////////////////

void Randomize(long Seed) {
  if (Seed>=0) lp_tt=Seed;
  else lp_tt=269167349;
  //else lp_tt=rand();
}

/////////////////////////////////////////////////////////////////////
// Rand
/////////////////////////////////////////////////////////////////////
// Returns and integer belonging to the [Min, Max] interval, using
// the selected random distribution
/////////////////////////////////////////////////////////////////////

int Rand(int Min,int Max,int Distribution) {

  // Implement the different distributions

  int tmp;
  if((Max-Min)>0)
  {
    tmp=(int)((randu(lp_tt)*(Max-Min+1))+Min);
    return(tmp);
  }
  else return Min;
}

/////////////////////////////////////////////////////////////////////
// GetIO
/////////////////////////////////////////////////////////////////////
// Returns the current number of major I/Os
/////////////////////////////////////////////////////////////////////

long GetIO() {

  struct rusage r_use;    // structure RUSAGE (resource usage)
  int gru;                // get resource usage

  gru=getrusage(RUSAGE_SELF,&r_use);
  // The call to getrusage provokes a warning at compile time
  // Ignore it
  if (gru==0) return r_use.ru_majflt;
  else {
    fprintf(stderr,"Erreur GETRUSAGE %d !\n",gru);
    return -1;
    }
}
